ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.27 by greg, Thu Oct 27 16:35:54 2011 UTC vs.
Revision 2.35 by greg, Wed May 9 17:40:17 2012 UTC

# Line 8 | Line 8
8   use strict;
9   use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14   my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
# Line 23 | Line 23 | my $geout = 1;
23   my $nproc = 1;
24   my $doforw = 0;
25   my $doback = 1;
26 < my $pctcull = 95;
26 > my $pctcull = 90;
27   my $gunit = "Meter";
28   my @dim;
29   # Get options
# Line 45 | Line 45 | while ($#ARGV >= 0) {
45          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46                  $doback = ("$ARGV[0]" =~ /^\+/);
47          } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49                  $pctcull = $ARGV[1];
50                  shift @ARGV;
51          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
# Line 321 | Line 322 | sub bg_tree_rtcontrib {
322   sub ttree_out {
323          my $forw = shift;
324          my $side = ("Back","Front")[$forw];
325 +        my $cmd;
326   # Only output one transmitted distribution, preferring backwards
327   if ( !$forw || !$doback ) {
328   print
# Line 335 | Line 337 | print
337                          <ScatteringDataType>BTDF</ScatteringDataType>
338                          <ScatteringData>
339   ';
340 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
341 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
342 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
343 <        "| rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
344 < die "Failure running rttree_reduce" if ( $? );
340 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
341 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
342 > if ($pctcull >= 0) {
343 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
344 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
345 >        system "$cmd" || die "Failure running rttree_reduce";
346 > } else {
347 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt";
348 >        print "{\n";
349 >        system "$cmd" || die "Failure running rcalc";
350 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
351 >                print "0\n";
352 >        }
353 >        print "}\n";
354 > }
355   print
356   '                       </ScatteringData>
357                  </WavelengthDataBlock>
# Line 361 | Line 373 | print
373                          <ScatteringDataType>BRDF</ScatteringDataType>
374                          <ScatteringData>
375   ';
376 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
377 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
378 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
379 <        "| rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
380 < die "Failure running rttree_reduce" if ( $? );
376 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
377 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
378 > if ($pctcull >= 0) {
379 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
380 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
381 >        system "$cmd" || die "Failure running rttree_reduce";
382 > } else {
383 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt";
384 >        print "{\n";
385 >        system "$cmd" || die "Failure running rcalc";
386 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
387 >                print "0\n";
388 >        }
389 >        print "}\n";
390 > }
391   print
392   '                       </ScatteringData>
393                  </WavelengthDataBlock>
# Line 382 | Line 404 | sub do_matrix_bsdf {
404   $tcal = '
405   DEGREE : PI/180;
406   sq(x) : x*x;
407 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
407 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
408   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
409   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
410   Kmax : Kaccum(Knaz(0));
# Line 403 | Line 425 | KprojOmega = PI * if(Kbin-.5,
425   $kcal = '
426   DEGREE : PI/180;
427   abs(x) : if(x, x, -x);
428 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
428 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
429   posangle(a) : if(-a, a + 2*PI, a);
430 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
430 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
431   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
432   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
433   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 437 | Line 459 | my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c
459          "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
460   my $rccmd = "rcalc -e '$tcal' " .
461          "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
462 <        q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
441 <        q[-o '${  oval  },'];
462 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
463   if ( $doforw ) {
464   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
465          "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
# Line 464 | Line 485 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
485   system "$cmd" || die "Failure running: $cmd\n";
486   @tbarr = `$rccmd $td/$bmodnm.flt`;
487   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
488 + chomp(@tbarr);
489   @rbarr = `$rccmd $td/$fmodnm.flt`;
490   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
491 + chomp(@rbarr);
492   }
493   # Output angle basis
494   print
# Line 474 | Line 497 | print
497                  <AngleBasis>
498                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
499                          <AngleBasisBlock>
500 <                                <Theta>0</Theta>
501 <                                <nPhis>1</nPhis>
502 <                                <ThetaBounds>
503 <                                        <LowerTheta>0</LowerTheta>
504 <                                        <UpperTheta>5</UpperTheta>
505 <                                </ThetaBounds>
483 <                                </AngleBasisBlock>
484 <                                <AngleBasisBlock>
485 <                                <Theta>10</Theta>
486 <                                <nPhis>8</nPhis>
487 <                                <ThetaBounds>
488 <                                        <LowerTheta>5</LowerTheta>
489 <                                        <UpperTheta>15</UpperTheta>
490 <                                </ThetaBounds>
491 <                                </AngleBasisBlock>
492 <                                <AngleBasisBlock>
493 <                                <Theta>20</Theta>
494 <                                <nPhis>16</nPhis>
495 <                                <ThetaBounds>
496 <                                        <LowerTheta>15</LowerTheta>
497 <                                        <UpperTheta>25</UpperTheta>
498 <                                </ThetaBounds>
499 <                                </AngleBasisBlock>
500 <                                <AngleBasisBlock>
501 <                                <Theta>30</Theta>
502 <                                <nPhis>20</nPhis>
503 <                                <ThetaBounds>
504 <                                        <LowerTheta>25</LowerTheta>
505 <                                        <UpperTheta>35</UpperTheta>
506 <                                </ThetaBounds>
507 <                                </AngleBasisBlock>
508 <                                <AngleBasisBlock>
509 <                                <Theta>40</Theta>
510 <                                <nPhis>24</nPhis>
511 <                                <ThetaBounds>
512 <                                        <LowerTheta>35</LowerTheta>
513 <                                        <UpperTheta>45</UpperTheta>
514 <                                </ThetaBounds>
515 <                                </AngleBasisBlock>
516 <                                <AngleBasisBlock>
517 <                                <Theta>50</Theta>
518 <                                <nPhis>24</nPhis>
519 <                                <ThetaBounds>
520 <                                        <LowerTheta>45</LowerTheta>
521 <                                        <UpperTheta>55</UpperTheta>
522 <                                </ThetaBounds>
523 <                                </AngleBasisBlock>
524 <                                <AngleBasisBlock>
525 <                                <Theta>60</Theta>
526 <                                <nPhis>24</nPhis>
527 <                                <ThetaBounds>
528 <                                        <LowerTheta>55</LowerTheta>
529 <                                        <UpperTheta>65</UpperTheta>
530 <                                </ThetaBounds>
531 <                                </AngleBasisBlock>
532 <                                <AngleBasisBlock>
533 <                                <Theta>70</Theta>
534 <                                <nPhis>16</nPhis>
535 <                                <ThetaBounds>
536 <                                        <LowerTheta>65</LowerTheta>
537 <                                        <UpperTheta>75</UpperTheta>
538 <                                </ThetaBounds>
539 <                                </AngleBasisBlock>
540 <                                <AngleBasisBlock>
541 <                                <Theta>82.5</Theta>
542 <                                <nPhis>12</nPhis>
543 <                                <ThetaBounds>
544 <                                        <LowerTheta>75</LowerTheta>
545 <                                        <UpperTheta>90</UpperTheta>
546 <                                </ThetaBounds>
500 >                        <Theta>0</Theta>
501 >                        <nPhis>1</nPhis>
502 >                        <ThetaBounds>
503 >                                <LowerTheta>0</LowerTheta>
504 >                                <UpperTheta>5</UpperTheta>
505 >                        </ThetaBounds>
506                          </AngleBasisBlock>
507 +                        <AngleBasisBlock>
508 +                        <Theta>10</Theta>
509 +                        <nPhis>8</nPhis>
510 +                        <ThetaBounds>
511 +                                <LowerTheta>5</LowerTheta>
512 +                                <UpperTheta>15</UpperTheta>
513 +                        </ThetaBounds>
514 +                        </AngleBasisBlock>
515 +                        <AngleBasisBlock>
516 +                        <Theta>20</Theta>
517 +                        <nPhis>16</nPhis>
518 +                        <ThetaBounds>
519 +                                <LowerTheta>15</LowerTheta>
520 +                                <UpperTheta>25</UpperTheta>
521 +                        </ThetaBounds>
522 +                        </AngleBasisBlock>
523 +                        <AngleBasisBlock>
524 +                        <Theta>30</Theta>
525 +                        <nPhis>20</nPhis>
526 +                        <ThetaBounds>
527 +                                <LowerTheta>25</LowerTheta>
528 +                                <UpperTheta>35</UpperTheta>
529 +                        </ThetaBounds>
530 +                        </AngleBasisBlock>
531 +                        <AngleBasisBlock>
532 +                        <Theta>40</Theta>
533 +                        <nPhis>24</nPhis>
534 +                        <ThetaBounds>
535 +                                <LowerTheta>35</LowerTheta>
536 +                                <UpperTheta>45</UpperTheta>
537 +                        </ThetaBounds>
538 +                        </AngleBasisBlock>
539 +                        <AngleBasisBlock>
540 +                        <Theta>50</Theta>
541 +                        <nPhis>24</nPhis>
542 +                        <ThetaBounds>
543 +                                <LowerTheta>45</LowerTheta>
544 +                                <UpperTheta>55</UpperTheta>
545 +                        </ThetaBounds>
546 +                        </AngleBasisBlock>
547 +                        <AngleBasisBlock>
548 +                        <Theta>60</Theta>
549 +                        <nPhis>24</nPhis>
550 +                        <ThetaBounds>
551 +                                <LowerTheta>55</LowerTheta>
552 +                                <UpperTheta>65</UpperTheta>
553 +                        </ThetaBounds>
554 +                        </AngleBasisBlock>
555 +                        <AngleBasisBlock>
556 +                        <Theta>70</Theta>
557 +                        <nPhis>16</nPhis>
558 +                        <ThetaBounds>
559 +                                <LowerTheta>65</LowerTheta>
560 +                                <UpperTheta>75</UpperTheta>
561 +                        </ThetaBounds>
562 +                        </AngleBasisBlock>
563 +                        <AngleBasisBlock>
564 +                        <Theta>82.5</Theta>
565 +                        <nPhis>12</nPhis>
566 +                        <ThetaBounds>
567 +                                <LowerTheta>75</LowerTheta>
568 +                                <UpperTheta>90</UpperTheta>
569 +                        </ThetaBounds>
570 +                        </AngleBasisBlock>
571                  </AngleBasis>
572          </DataDefinition>
573   ';
# Line 565 | Line 588 | print
588   # Output front transmission (transposed order)
589   for (my $od = 0; $od < $ndiv; $od++) {
590          for (my $id = 0; $id < $ndiv; $id++) {
591 <                print $tfarr[$ndiv*$id + $od];
591 >                print $tfarr[$ndiv*$id + $od], ",\n";
592          }
593          print "\n";
594   }
# Line 588 | Line 611 | print
611   # Output front reflection (transposed order)
612   for (my $od = 0; $od < $ndiv; $od++) {
613          for (my $id = 0; $id < $ndiv; $id++) {
614 <                print $rfarr[$ndiv*$id + $od];
614 >                print $rfarr[$ndiv*$id + $od], ",\n";
615          }
616          print "\n";
617   }
# Line 615 | Line 638 | print
638   # Output back transmission (transposed order)
639   for (my $od = 0; $od < $ndiv; $od++) {
640          for (my $id = 0; $id < $ndiv; $id++) {
641 <                print $tbarr[$ndiv*$id + $od];
641 >                print $tbarr[$ndiv*$id + $od], ",\n";
642          }
643          print "\n";
644   }
# Line 638 | Line 661 | print
661   # Output back reflection (transposed order)
662   for (my $od = 0; $od < $ndiv; $od++) {
663          for (my $id = 0; $id < $ndiv; $id++) {
664 <                print $rbarr[$ndiv*$id + $od];
664 >                print $rbarr[$ndiv*$id + $od], ",\n";
665          }
666          print "\n";
667   }

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines